## ros-galactic-rclcpp-action 9.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_action)

find_package(ament_cmake_ros REQUIRED)
find_package(action_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rosidl_runtime_c REQUIRED)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(
    -Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual
    -Wformat=2 -Wconversion -Wshadow -Wsign-conversion -Wcast-qual
  )
endif()

set(${PROJECT_NAME}_SRCS
  src/client.cpp
  src/qos.cpp
  src/server.cpp
  src/server_goal_handle.cpp
  src/types.cpp
)

add_library(${PROJECT_NAME}
  ${${PROJECT_NAME}_SRCS})

target_include_directories(${PROJECT_NAME}
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")

ament_target_dependencies(${PROJECT_NAME}
  "action_msgs"
  "rcl_action"
  "rclcpp"
  "rosidl_runtime_c"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RCLCPP_ACTION_BUILDING_LIBRARY")

install(
  DIRECTORY include/
  DESTINATION include)

install(
  TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})

ament_export_dependencies(ament_cmake)
ament_export_dependencies(action_msgs)
ament_export_dependencies(rclcpp)
ament_export_dependencies(rcl_action)
ament_export_dependencies(rosidl_runtime_c)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  set(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS ${rclcpp_INCLUDE_DIRS})
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(test/benchmark)

  ament_add_gtest(test_client test/test_client.cpp TIMEOUT 180)
  if(TARGET test_client)
    ament_target_dependencies(test_client
      "rcutils"
      "test_msgs"
    )
    target_link_libraries(test_client
      ${PROJECT_NAME}
      mimick
    )
  endif()

  ament_add_gtest(test_server test/test_server.cpp TIMEOUT 180)
  if(TARGET test_server)
    ament_target_dependencies(test_server
      "rcutils"
      "test_msgs"
    )
    target_link_libraries(test_server
      ${PROJECT_NAME}
      mimick
    )
  endif()

  ament_add_gtest(test_server_goal_handle test/test_server_goal_handle.cpp)
  if(TARGET test_server_goal_handle)
    ament_target_dependencies(test_server_goal_handle
      "rcutils"
      "test_msgs"
    )
    target_link_libraries(test_server_goal_handle
      ${PROJECT_NAME}
      mimick
    )
  endif()

  ament_add_gtest(test_traits test/test_traits.cpp)
  if(TARGET test_traits)
    ament_target_dependencies(test_traits
      "test_msgs"
    )
    target_link_libraries(test_traits
      ${PROJECT_NAME}
    )
  endif()

  ament_add_gtest(test_types test/test_types.cpp)
  if(TARGET test_types)
    ament_target_dependencies(test_types
      "test_msgs"
    )
    target_link_libraries(test_types
      ${PROJECT_NAME}
    )
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-galactic-rclcpp-action (9.2.2-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Dec 2022 08:00:00 -0000

ros-galactic-rclcpp-action (9.2.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 28 Apr 2022 07:00:00 -0000

ros-galactic-rclcpp-action (9.2.0-1focal) focal; urgency=high

  * Fixed a bug where it would occasionally miss a goal result, which was caused by race condition (#1677 <https://github.com/ros2/rclcpp/issues/1677>) (#1683 <https://github.com/ros2/rclcpp/issues/1683>)
    * Co-authored-by: Kaven Yau <mailto:kavenyau@foxmail.com>
  * Contributors: Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 17 Sep 2021 07:00:00 -0000

ros-galactic-rclcpp-action (9.1.0-1focal) focal; urgency=high

  * Bump the benchmark timeout for benchmark_action_client (#1672 <https://github.com/ros2/rclcpp/issues/1672>)
  * Contributors: Scott K Logan

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 20 May 2021 07:00:00 -0000

ros-galactic-rclcpp-action (9.0.3-1focal) focal; urgency=high

  * Returns CancelResponse::REJECT while goal handle failed to transit to CANCELING state (#1641 <https://github.com/ros2/rclcpp/issues/1641>) (#1653 <https://github.com/ros2/rclcpp/issues/1653>)
  * Fix action server deadlock issue that caused by other mutexes locked in CancelCallback (#1635 <https://github.com/ros2/rclcpp/issues/1635>) (#1646 <https://github.com/ros2/rclcpp/issues/1646>)
  * Contributors: Jacob Perron, Kaven Yau, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 10 May 2021 07:00:00 -0000

ros-galactic-rclcpp-action (9.0.2-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 14 Apr 2021 07:00:00 -0000

ros-galactic-rclcpp-action (9.0.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-galactic-rclcpp-action (9.0.0-1focal) focal; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#1615 <https://github.com/ros2/rclcpp/issues/1615>)
  * Contributors: shonigmann

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Apr 2021 07:00:00 -0000

ros-galactic-rclcpp-action (8.2.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 31 Mar 2021 07:00:00 -0000

ros-galactic-rclcpp-action (8.1.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Mar 2021 07:00:00 -0000

ros-galactic-rclcpp-action (8.0.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Mar 2021 07:00:00 -0000

ros-galactic-rclcpp-action (7.0.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 22 Mar 2021 07:00:00 -0000

ros-galactic-rclcpp-action (7.0.0-1focal) focal; urgency=high

  * Add support for rmw_connextdds (#1574 <https://github.com/ros2/rclcpp/issues/1574>)
  * node_handle must be destroyed after client_handle to prevent memory leak (#1562 <https://github.com/ros2/rclcpp/issues/1562>)
  * Contributors: Andrea Sorbini, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 18 Mar 2021 07:00:00 -0000

ros-galactic-rclcpp-action (6.3.1-1focal) focal; urgency=high

  * Finalize rcl_handle to prevent leak (#1528 <https://github.com/ros2/rclcpp/issues/1528>) (#1529 <https://github.com/ros2/rclcpp/issues/1529>)
  * Fix #1526 <https://github.com/ros2/rclcpp/issues/1526>. (#1527 <https://github.com/ros2/rclcpp/issues/1527>)
  * Contributors: y-okumura-isp

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 08 Feb 2021 08:00:00 -0000

ros-galactic-rclcpp-action (6.3.0-1focal) focal; urgency=high

  * Fix action server deadlock (#1285 <https://github.com/ros2/rclcpp/issues/1285>) (#1313 <https://github.com/ros2/rclcpp/issues/1313>)
  * Contributors: Daisuke Sato

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jan 2021 08:00:00 -0000

ros-galactic-rclcpp-action (6.2.0-1focal) focal; urgency=high

  * Goal response callback compatibility shim with deprecation of old signature (#1495 <https://github.com/ros2/rclcpp/issues/1495>)
  * [rclcpp_action] Add warnings (#1405 <https://github.com/ros2/rclcpp/issues/1405>)
  * Contributors: Audrow Nash, Ivan Santiago Paunovic

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 Jan 2021 08:00:00 -0000

ros-galactic-rclcpp-action (6.1.0-1focal) focal; urgency=high

  * Update QDs to QL 1 (#1477 <https://github.com/ros2/rclcpp/issues/1477>)
  * Contributors: Stephen Brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 10 Dec 2020 08:00:00 -0000

ros-galactic-rclcpp-action (6.0.0-1focal) focal; urgency=high

  * Add take_data to Waitable and data to AnyExecutable (#1241 <https://github.com/ros2/rclcpp/issues/1241>)
  * Fix test crashes on CentOS 7 (#1449 <https://github.com/ros2/rclcpp/issues/1449>)
  * Bump rclcpp packages to Quality Level 2 (#1445 <https://github.com/ros2/rclcpp/issues/1445>)
  * Add rclcpp_action action_server benchmarks (#1433 <https://github.com/ros2/rclcpp/issues/1433>)
  * Contributors: Audrow Nash, Chris Lalancette, Louise Poubel, brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 18 Nov 2020 08:00:00 -0000

ros-galactic-rclcpp-action (5.1.0-1focal) focal; urgency=high

  * Benchmark rclcpp_action action_client (#1429 <https://github.com/ros2/rclcpp/issues/1429>)
  * Add missing locking to the rclcpp_action::ServerBase. (#1421 <https://github.com/ros2/rclcpp/issues/1421>)
  * Increase test timeouts of slow running tests with rmw_connext_cpp (#1400 <https://github.com/ros2/rclcpp/issues/1400>)
  * Update maintainers (#1384 <https://github.com/ros2/rclcpp/issues/1384>)
  * Increase coverage rclcpp_action to 95% (#1290 <https://github.com/ros2/rclcpp/issues/1290>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic, brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 02 Nov 2020 08:00:00 -0000



=== debian/control ===
Source: ros-galactic-rclcpp-action
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-action-msgs, ros-galactic-ament-cmake, ros-galactic-ament-cmake-gtest <!nocheck>, ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-mimick-vendor <!nocheck>, ros-galactic-performance-test-fixture <!nocheck>, ros-galactic-rcl-action, ros-galactic-rclcpp, ros-galactic-rosidl-runtime-c, ros-galactic-test-msgs <!nocheck>, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rclcpp-action
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-action-msgs, ros-galactic-ament-cmake, ros-galactic-rcl-action, ros-galactic-rclcpp, ros-galactic-rosidl-runtime-c, ros-galactic-ros-workspace
Description: Adds action APIs for C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rclcpp-action//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
